SystemOrganization addCategory: #'CodeImport-Tests'!

TestCase subclass: #ChunkImportTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeImport-Tests'!

!ChunkImportTestCase methodsFor: 'auxiliar' stamp: 'GuillermoPolito 5/5/2012 17:26'!
importAClass
	^CodeImporter evaluateString: 'Object subclass: #CodeImportTestCaseTestClass
			instanceVariableNames: ''var1 var2 var3''
			classVariableNames: ''''
			poolDictionaries: ''''
			category: ''CodeImporter-Tests-Garbage''!!'.! !

!ChunkImportTestCase methodsFor: 'importing-code' stamp: 'GuillermoPolito 5/5/2012 15:41'!
testImportAClass
	| class |
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		self assert: #CodeImportTestCaseTestClass equals: class name.
		self assert: (class instVarNames includes: 'var1').
		self assert: (class instVarNames includes: 'var2').
		self assert: (class instVarNames includes: 'var3').
		self assert: class category equals: 'CodeImporter-Tests-Garbage'.
		
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'importing-code' stamp: 'GuillermoPolito 5/5/2012 17:26'!
testImportAClassCategory
	| class classOrganizationString chunk |
	classOrganizationString := '(''testing'' testImportAClass testImportAMethod)
(''auxiliar'' importAClass)'.
	chunk := '!!{1} reorganize!!'.
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		
		"we write the methods we will categorize"
		class compileSilently: 'testImportAClass'.
		class compileSilently: 'testImportAMethod'.
		class compileSilently: 'importAClass'.
		
		CodeImporter evaluateString: (chunk format: { class name asString }), classOrganizationString.
		self assert: classOrganizationString trimBoth equals: class organization stringForFileOut trimBoth.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'importing-code' stamp: 'GuillermoPolito 5/5/2012 17:27'!
testImportAClassComment
	| class comment |
	comment := 'I''m a nice comment, treat me well :).'.
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		CodeImporter evaluateString: ('!!{1} commentStamp: ''<historical>'' prior: 0!!{2}!!' format: { class name asString . comment }).
		self assert: comment equals: class comment.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'importing-code' stamp: 'GuillermoPolito 5/5/2012 21:59'!
testImportAClassCommentWithExclamationMarks
	| class comment commentToWrite |
	comment := 'I''m a nice comment!!, treat me well :).'.
	commentToWrite := 'I''m a nice comment!!!!, treat me well :).' replaceAll: '!!' with: '!!!!'.
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		CodeImporter evaluateString: ('!!{1} commentStamp: ''<historical>'' prior: 0!!{2}!!' format: { class name asString . commentToWrite }).
		self assert: comment equals: class comment.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'importing-code' stamp: 'GuillermoPolito 5/5/2012 17:26'!
testImportAMethod
	| class comment |
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		CodeImporter evaluateString: ('!!{1} methodsFor: ''some protocol'' stamp: ''GuillermoPolito 5/2/2012 13:35''!!someMethod
	^true' format: { class name asString }).
	
		self assert: class new someMethod.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'importing-code' stamp: 'GuillermoPolito 5/5/2012 22:42'!
testImportAMethodWithSpacesInItsCategory
	| class comment |
	SystemChangeNotifier uniqueInstance doSilently: [[
		class := self importAClass.
		CodeImporter evaluateString: ('!!{1} methodsFor: ''some protocol'' stamp: ''GuillermoPolito 5/2/2012 13:35''!!someMethod
	^true' format: { class name asString }).
	
		self assert: (class >> #someMethod) category equals: 'some protocol'.
	] ensure: [ class ifNotNil: [ class removeFromSystem ] ] ]! !

!ChunkImportTestCase methodsFor: 'importing-methods' stamp: 'GuillermoPolito 5/5/2012 17:26'!
testImportFromReadStream
	self assert: 4 equals: (CodeImporter evaluateReadStream: '2+2!!' readStream)! !

!ChunkImportTestCase methodsFor: 'importing-methods' stamp: 'GuillermoPolito 5/5/2012 17:26'!
testImportString
	self assert: 4 equals: (CodeImporter evaluateString: '2+2!!')! !
